% LANGUAGE AND FONT ENCODING PACKAGES
\usepackage[english]{babel}
\usepackage[utf8x]{inputenc}
\usepackage[T1]{fontenc}

% PAGE FORMATTING PACKAGES
% \usepackage{fullpage} % FOR DRAFTS ONLY
\usepackage[a4paper,hmargin=1in,vmargin=1.25in]{geometry} % FOR DRAFTS ONLY
% \pagestyle{headings}
% \usepackage{fancyhdr}

% KOMA PACKAGES. Can't remember why I included them, maybe for algorithms?
% \addtokomafont{labelinglabel}{\sffamily}
% \usepackage{scrextend}

% MATH PACKAGES
\usepackage{amsmath,amsthm,amssymb,bbm}

% ENVIRONMENTS PACKAGES
\usepackage{enumitem}

% FONTS PACKAGES
\usepackage{amsfonts}
\usepackage{bm}
\usepackage{stmaryrd}

% UTILITY PACKAGES
\RequirePackage[l2tabu, orthodox]{nag}
\usepackage{booktabs}
\usepackage{authblk}
\usepackage{makeidx}
\usepackage{framed}
\usepackage{graphicx}
\usepackage[colorinlistoftodos]{todonotes}
\usepackage{hyperref}
\usepackage{url}
\usepackage{color}
\usepackage{xspace}
\usepackage[ruled,vlined]{algorithm2e}
% \include{pythonlisting} %not sure what this is doing
\usepackage{algpseudocode}
\usepackage{float}
\usepackage{tikz}
\usetikzlibrary{positioning,chains,fit,shapes,calc}
\usepackage{cleveref} % must be last \usepackage command, apparently

% Customizing algorithm package
\newenvironment{fun}[1][htb]
  {\renewcommand{\algorithmcfname}{Function}% Update algorithm name
   \begin{algorithm}[#1]%
  }{\end{algorithm}}

% CUSTOM THEOREM ENVIRONMENTS
% REMOVE STANDARD ONE (THM ETC.) IF USING LLNCS OR IEEE TEMPLATES
\theoremstyle{plain}
\newtheorem{thm}{Theorem}
\newtheorem{theorem}{Theorem}
\newtheorem*{thm*}{Theorem}
\newtheorem{prop}[thm]{Proposition}
\newtheorem*{prop*}{Proposition}
\newtheorem{lemma}[thm]{Lemma}
\newtheorem*{lem*}{Lemma}
\newtheorem*{claim}{Claim}
\newtheorem{conject}[thm]{Conjecture}
\newtheorem{corollary}[thm]{Corollary}
\theoremstyle{definition}
\newtheorem{defi}{Definition}
\newtheorem{problem}{Problem}
\newtheorem{assumption}{Assumption}
\newtheorem{construction}{Construction}
\theoremstyle{plain}
\newtheorem{protocol}{Protocol}
\newtheorem{algo}{Algorithm}
\newtheorem{conve}{Convention}
\newtheorem*{conve*}{Convention}
\theoremstyle{remark}
\newtheorem{rmk}{Remark}
\newtheorem*{rmk*}{Remark}
\newtheorem{notation}{Notation}
\newtheorem*{notation*}{Notation}
\newtheorem{prope}{Property}

% ABBREVIATIONS

% FONT STYLES
\newcommand*{\tsf}{\textsf}
\newcommand*{\tbf}{\textbf}
\newcommand*{\mr}{\mathrm}
\newcommand*{\mt}{\mathtt}
\newcommand*{\mc}{\mathcal}
\newcommand*{\mbb}{\mathbb}
\newcommand*{\mb}{\mathbf}
\newcommand*{\bs}{\boldsymbol}
\newcommand*{\ms}{\mathsf}
\newcommand*{\mf}{\mathfrak}
\newcommand*{\mtt}{\mathtt}
 
% NUMBER SETS, ALGEBRA
\newcommand*{\F}{\ensuremath{\mbb{F}}}
\newcommand*{\R}{\ensuremath{\mbb{R}}}
\newcommand*{\N}{\ensuremath{\mbb{N}}}
\newcommand*{\Z}{\ensuremath{\mbb{Z}}}
\newcommand*{\Q}{\ensuremath{\mbb{Q}}}

% OTHERS
\newcommand*{\x}{\ensuremath{\mb{x}}}
\newcommand*{\y}{\ensuremath{\mb{y}}}
\newcommand*{\vv}{\ensuremath{\mb{v}}}
\newcommand*{\z}{\ensuremath{\mb{z}}}
\newcommand*{\e}{\ensuremath{\mb{e}}}
\newcommand*{\m}{\ensuremath{\mb{m}}}
\newcommand*{\s}{\ensuremath{\mb{s}}}
\newcommand*{\cc}{\ensuremath{\mb{c}}}
\newcommand*{\kk}{\ensuremath{\mb{k}}}
\newcommand*{\h}{\ensuremath{\mb{h}}}
\newcommand*{\M}{\ensuremath{\mb{M}}}
\newcommand*{\C}{\ensuremath{\mc{C}}}
\newcommand*{\X}{\ensuremath{\mb{X}}}
\newcommand*{\Y}{\ensuremath{\mb{Y}}}
\newcommand*{\Zeta}{\ensuremath{\mb{Z}}}
\newcommand*{\W}{\ensuremath{\mb{W}}}
\newcommand*{\A}{\ensuremath{\mc{A}}}
\newcommand*{\set}{\ensuremath{\mc{S}}}

% ENSURE "LEFT" AND "RIGHT" COMMANDS DO NOT ADD WHITE SPACE
\let\originalleft\left
\let\originalright\right
\def\left#1{\mathopen{}\originalleft#1}
\def\right#1{\originalright#1\mathclose{}}

% DOCUMENT-SPECIFIC VARIABLES
\newcommand*{\clusnum}{\ensuremath{k}}

% SEMANTIC MACROS
% \newcommand*{\secshared}[1]{\left\langle #1 \right\rangle}

% correct bad hyphenation here

% BOX ENVIRONMENT
% Usage: \begin{boxfig}[placement]{Caption}{Label}
\newenvironment{boxfig}[3][htb!]{
    \begin{figure}[#1]
    \newcommand{\FigCaption}{#2}
    \newcommand{\FigLabel}{#3}
    \vspace{-0.5cm}
    \begin{center}
        \begin{small}
        \begin{tabular}{@{}|@{~~}l@{~~}|@{}}
        \hline
        \rule[-1.5ex]{0pt}{1ex}\begin{minipage}[b]{.96\linewidth}
        \vspace{1ex}
        \smallskip
}
{%
        \end{minipage}\\
        \hline
        \end{tabular}
        \end{small}
        \vspace{-0.25cm}
        \caption{\FigCaption}
        \label{fig:\FigLabel}
    \end{center}
  \vspace{-1cm}
    \end{figure}
}

\newenvironment{boxfig_morespace}[3][htb!]{
    \begin{figure}[#1]
    \newcommand{\FigCaption}{#2}
    \newcommand{\FigLabel}{#3}
    \vspace{-0.25cm}
    \begin{center}
        \begin{small}
        \begin{tabular}{@{}|@{~~}l@{~~}|@{}}
        \hline
        \rule[-1.5ex]{0pt}{1ex}\begin{minipage}[b]{.96\linewidth}
        \vspace{1ex}
        \smallskip
}
{%
        \end{minipage}\\
        \hline
        \end{tabular}
        \end{small}
        \vspace{-0.25cm}
        \caption{\FigCaption}
        \label{fig:\FigLabel}
    \end{center}
  \vspace{-0.5cm}
    \end{figure}
}
